import _extends from "@babel/runtime/helpers/extends";

/**
 * Copyright IBM Corp. 2016, 2018
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import React from 'react';
import { action } from '@storybook/addon-actions';
import { Add16 } from '@carbon/icons-react';
import { default as Button, ButtonSkeleton } from '../';
import ButtonSet from '../../ButtonSet';
export default {
  title: 'Components/Button',
  component: Button,
  subcomponents: {
    ButtonSet: ButtonSet,
    ButtonSkeleton: ButtonSkeleton
  },
  argTypes: {
    kind: {
      options: ['primary', 'secondary', 'tertiary', 'ghost', 'danger', 'danger--tertiary', 'danger--ghost'],
      control: {
        type: 'select'
      }
    },
    size: {
      options: ['sm', 'md', 'lg', 'xl', '2xl'],
      control: {
        type: 'select'
      }
    },
    children: {
      control: false
    },
    renderIcon: {
      control: false
    },
    as: {
      control: false
    },
    small: {
      table: {
        disable: true
      }
    }
  }
};
export var _Default = function _Default(args) {
  return /*#__PURE__*/React.createElement(Button, args, "Button");
};
export var Secondary = function Secondary(args) {
  return /*#__PURE__*/React.createElement(Button, _extends({
    kind: "secondary"
  }, args), "Button");
};
export var Tertiary = function Tertiary(args) {
  return /*#__PURE__*/React.createElement(Button, _extends({
    kind: "tertiary"
  }, args), "Button");
};
export var Danger = function Danger(args) {
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Button, _extends({
    kind: "danger"
  }, args), "Button"), "\xA0", /*#__PURE__*/React.createElement(Button, _extends({
    kind: "danger--tertiary"
  }, args), "Tertiary Danger Button"), "\xA0", /*#__PURE__*/React.createElement(Button, _extends({
    kind: "danger--ghost"
  }, args), "Ghost Danger Button"));
};
export var Ghost = function Ghost(args) {
  return /*#__PURE__*/React.createElement(Button, _extends({
    kind: "ghost"
  }, args), "Button");
};
export var IconButton = function IconButton(args) {
  return /*#__PURE__*/React.createElement(Button, _extends({
    renderIcon: Add16,
    iconDescription: "Icon Description",
    hasIconOnly: true,
    onClick: action('onClick')
  }, args));
};
export var SetOfButtons = function SetOfButtons(args) {
  return /*#__PURE__*/React.createElement(ButtonSet, null, /*#__PURE__*/React.createElement(Button, _extends({
    kind: "secondary"
  }, args), "Secondary button"), /*#__PURE__*/React.createElement(Button, _extends({
    kind: "primary"
  }, args), "Primary button"));
};
export var Skeleton = function Skeleton() {
  return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(ButtonSkeleton, null), "\xA0", /*#__PURE__*/React.createElement(ButtonSkeleton, {
    size: "sm"
  }));
};