/**
 * Copyright IBM Corp. 2016, 2018
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import React from 'react';
import { Tabs, TabList, Tab, TabPanels, TabPanel, IconTab } from './Tabs';
import Button from '../../Button';
import TabsSkeleton from './Tabs.Skeleton';
import { Monster20, Corn20, Bat20, Monster16, Corn16, Bat16 } from '@carbon/icons-react';
import { unstable_FeatureFlags as FeatureFlags } from 'carbon-components-react';
export default {
  title: 'Components/Tabs',
  component: Tabs,
  decorators: [function (Story) {
    return /*#__PURE__*/React.createElement(FeatureFlags, {
      flags: {
        'enable-v11-release': true
      }
    }, /*#__PURE__*/React.createElement(Story, null));
  }],
  subcomponents: {
    TabList: TabList,
    Tab: Tab,
    TabPanels: TabPanels,
    TabPanel: TabPanel
  },
  parameters: {}
};
export var Default = function Default() {
  return /*#__PURE__*/React.createElement("div", {
    style: {
      width: '400px'
    }
  }, /*#__PURE__*/React.createElement(Tabs, null, /*#__PURE__*/React.createElement(TabList, {
    "aria-label": "List of tabs"
  }, /*#__PURE__*/React.createElement(Tab, null, "Tab Label 1"), /*#__PURE__*/React.createElement(Tab, null, "Tab Label 2"), /*#__PURE__*/React.createElement(Tab, {
    disabled: true
  }, "Tab Label 3"), /*#__PURE__*/React.createElement(Tab, null, "Tab Label 4 with a very long long label"), /*#__PURE__*/React.createElement(Tab, null, "Tab Label 5"), /*#__PURE__*/React.createElement(Tab, null, "Tab Label 6"), /*#__PURE__*/React.createElement(Tab, null, "Tab Label 7"), /*#__PURE__*/React.createElement(Tab, null, "Tab Label 8")), /*#__PURE__*/React.createElement(TabPanels, null, /*#__PURE__*/React.createElement(TabPanel, null, "Tab Panel 1 ", /*#__PURE__*/React.createElement(Button, null, "Example button")), /*#__PURE__*/React.createElement(TabPanel, null, "Tab Panel 2"), /*#__PURE__*/React.createElement(TabPanel, null, "Tab Panel 3"), /*#__PURE__*/React.createElement(TabPanel, null, "Tab Panel 4"), /*#__PURE__*/React.createElement(TabPanel, null, "Tab Panel 5"), /*#__PURE__*/React.createElement(TabPanel, null, "Tab Panel 6"), /*#__PURE__*/React.createElement(TabPanel, null, "Tab Panel 7"), /*#__PURE__*/React.createElement(TabPanel, null, "Tab Panel 8"))));
};
export var Manual = function Manual() {
  return /*#__PURE__*/React.createElement("div", {
    style: {
      width: '400px'
    }
  }, /*#__PURE__*/React.createElement(Tabs, null, /*#__PURE__*/React.createElement(TabList, {
    activation: "manual",
    "aria-label": "List of tabs"
  }, /*#__PURE__*/React.createElement(Tab, null, "Tab Label 1"), /*#__PURE__*/React.createElement(Tab, null, "Tab Label 2"), /*#__PURE__*/React.createElement(Tab, {
    disabled: true
  }, "Tab Label 3"), /*#__PURE__*/React.createElement(Tab, null, "Tab Label 4 with a very long long label"), /*#__PURE__*/React.createElement(Tab, null, "Tab Label 5"), /*#__PURE__*/React.createElement(Tab, null, "Tab Label 6"), /*#__PURE__*/React.createElement(Tab, null, "Tab Label 7"), /*#__PURE__*/React.createElement(Tab, null, "Tab Label 8")), /*#__PURE__*/React.createElement(TabPanels, null, /*#__PURE__*/React.createElement(TabPanel, null, "Tab Panel 1 ", /*#__PURE__*/React.createElement(Button, null, "Example button")), /*#__PURE__*/React.createElement(TabPanel, null, "Tab Panel 2"), /*#__PURE__*/React.createElement(TabPanel, null, "Tab Panel 3"), /*#__PURE__*/React.createElement(TabPanel, null, "Tab Panel 4"), /*#__PURE__*/React.createElement(TabPanel, null, "Tab Panel 5"), /*#__PURE__*/React.createElement(TabPanel, null, "Tab Panel 6"), /*#__PURE__*/React.createElement(TabPanel, null, "Tab Panel 7"), /*#__PURE__*/React.createElement(TabPanel, null, "Tab Panel 8"))));
};
export var Icon20Only = function Icon20Only() {
  return /*#__PURE__*/React.createElement(Tabs, null, /*#__PURE__*/React.createElement(TabList, {
    iconSize: "lg",
    "aria-label": "List of tabs"
  }, /*#__PURE__*/React.createElement(IconTab, {
    label: "Monster",
    disabled: true
  }, /*#__PURE__*/React.createElement(Monster20, {
    "aria-label": "Monster"
  })), /*#__PURE__*/React.createElement(IconTab, {
    label: "Corn"
  }, /*#__PURE__*/React.createElement(Corn20, {
    "aria-label": "Corn"
  })), /*#__PURE__*/React.createElement(IconTab, {
    label: "Bat"
  }, /*#__PURE__*/React.createElement(Bat20, {
    "aria-label": "Bat"
  }))), /*#__PURE__*/React.createElement(TabPanels, null, /*#__PURE__*/React.createElement(TabPanel, null, "Tab Panel 1"), /*#__PURE__*/React.createElement(TabPanel, null, "Tab Panel 2"), /*#__PURE__*/React.createElement(TabPanel, null, "Tab Panel 3")));
};
export var IconOnly = function IconOnly() {
  return /*#__PURE__*/React.createElement(Tabs, null, /*#__PURE__*/React.createElement(TabList, {
    iconSize: "default",
    "aria-label": "List of tabs"
  }, /*#__PURE__*/React.createElement(IconTab, {
    label: "Monster",
    disabled: true
  }, /*#__PURE__*/React.createElement(Monster16, {
    "aria-label": "Monster"
  })), /*#__PURE__*/React.createElement(IconTab, {
    label: "Corn"
  }, /*#__PURE__*/React.createElement(Corn16, {
    "aria-label": "Corn"
  })), /*#__PURE__*/React.createElement(IconTab, {
    label: "Bat"
  }, /*#__PURE__*/React.createElement(Bat16, {
    "aria-label": "Bat"
  }))), /*#__PURE__*/React.createElement(TabPanels, null, /*#__PURE__*/React.createElement(TabPanel, null, "Tab Panel 1"), /*#__PURE__*/React.createElement(TabPanel, null, "Tab Panel 2"), /*#__PURE__*/React.createElement(TabPanel, null, "Tab Panel 3")));
};
export var Contained = function Contained() {
  return /*#__PURE__*/React.createElement(Tabs, null, /*#__PURE__*/React.createElement(TabList, {
    "aria-label": "List of tabs",
    contained: true
  }, /*#__PURE__*/React.createElement(Tab, null, "Tab Label 1"), /*#__PURE__*/React.createElement(Tab, null, "Tab Label 2"), /*#__PURE__*/React.createElement(Tab, {
    disabled: true
  }, "Tab Label 3"), /*#__PURE__*/React.createElement(Tab, null, "Tab Label 4 with a very long long title"), /*#__PURE__*/React.createElement(Tab, null, "Tab Label 5")), /*#__PURE__*/React.createElement(TabPanels, null, /*#__PURE__*/React.createElement(TabPanel, null, "Tab Panel 1"), /*#__PURE__*/React.createElement(TabPanel, null, "Tab Panel 2 ", /*#__PURE__*/React.createElement(Button, null, "Example button")), /*#__PURE__*/React.createElement(TabPanel, null, "Tab Panel 3"), /*#__PURE__*/React.createElement(TabPanel, null, "Tab Panel 4"), /*#__PURE__*/React.createElement(TabPanel, null, "Tab Panel 5")));
};
export var Skeleton = function Skeleton() {
  return /*#__PURE__*/React.createElement("div", {
    style: {
      maxWidth: '100%'
    }
  }, /*#__PURE__*/React.createElement(TabsSkeleton, null));
};