"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.Skeleton = exports.SingleWithCalendarWithLayer = exports.SingleWithCalendar = exports.SimpleWithLayer = exports.Simple = exports.RangeWithCalendarWithLayer = exports.RangeWithCalendar = exports.DatePickerPlayground = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireDefault(require("react"));

var _addonActions = require("@storybook/addon-actions");

var _DatePicker = _interopRequireDefault(require("./DatePicker"));

var _DatePicker2 = _interopRequireDefault(require("../DatePicker.Skeleton"));

var _DatePickerInput = _interopRequireDefault(require("../../DatePickerInput"));

var _Layer = require("../../Layer");

/**
 * Copyright IBM Corp. 2016, 2018
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
var props = {
  datePicker: function datePicker() {
    return {
      dateFormat: 'm/d/Y',
      id: 'date-picker',
      light: false,
      datePickerType: 'single',
      minDate: '11/15/2020',
      maxDate: '11/01/2040',
      disable: ['07/15/2021'],
      onClose: (0, _addonActions.action)('onClose'),
      onOpen: (0, _addonActions.action)('onOpen')
    };
  },
  datePickerInput: function datePickerInput() {
    return {
      id: 'date-picker-input-id',
      className: 'some-class',
      size: undefined,
      labelText: 'Date Picker label',
      pattern: 'd{1,2}/d{4}',
      placeholder: 'mm/dd/yyyy',
      disabled: false,
      invalid: false,
      invalidText: 'A valid date is required',
      warn: false,
      warnText: 'Selected dates may cause conflicts',
      iconDescription: 'Icon description'
    };
  }
};
var _default = {
  title: 'Components/DatePicker',
  component: _DatePicker.default,
  argTypes: {
    size: {
      options: ['sm', 'md', 'lg'],
      control: {
        type: 'select'
      },
      table: {
        category: 'DatePickerInput'
      }
    }
  },
  args: {
    size: 'md'
  },
  subcomponents: {
    DatePickerInput: _DatePickerInput.default,
    DatePickerSkeleton: _DatePicker2.default
  }
};
exports.default = _default;

var Simple = function Simple(args) {
  return /*#__PURE__*/_react.default.createElement(_DatePicker.default, (0, _extends2.default)({
    datePickerType: "simple"
  }, args), /*#__PURE__*/_react.default.createElement(_DatePickerInput.default, (0, _extends2.default)({
    placeholder: "mm/dd/yyyy",
    labelText: "Date Picker label",
    id: "date-picker-simple"
  }, args)));
};

exports.Simple = Simple;

var SingleWithCalendar = function SingleWithCalendar(args) {
  return /*#__PURE__*/_react.default.createElement(_DatePicker.default, (0, _extends2.default)({
    datePickerType: "single"
  }, args), /*#__PURE__*/_react.default.createElement(_DatePickerInput.default, (0, _extends2.default)({
    placeholder: "mm/dd/yyyy",
    labelText: "Date Picker label",
    id: "date-picker-single"
  }, args)));
};

exports.SingleWithCalendar = SingleWithCalendar;

var RangeWithCalendar = function RangeWithCalendar(args) {
  return /*#__PURE__*/_react.default.createElement(_DatePicker.default, (0, _extends2.default)({
    datePickerType: "range"
  }, args), /*#__PURE__*/_react.default.createElement(_DatePickerInput.default, (0, _extends2.default)({
    id: "date-picker-input-id-start",
    placeholder: "mm/dd/yyyy",
    labelText: "Start date"
  }, args)), /*#__PURE__*/_react.default.createElement(_DatePickerInput.default, (0, _extends2.default)({
    id: "date-picker-input-id-finish",
    placeholder: "mm/dd/yyyy",
    labelText: "End date"
  }, args)));
};

exports.RangeWithCalendar = RangeWithCalendar;

var SimpleWithLayer = function SimpleWithLayer(args) {
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_DatePicker.default, (0, _extends2.default)({
    datePickerType: "simple"
  }, args), /*#__PURE__*/_react.default.createElement(_DatePickerInput.default, (0, _extends2.default)({
    placeholder: "mm/dd/yyyy",
    labelText: "Date Picker label",
    id: "date-picker-simple"
  }, args))), /*#__PURE__*/_react.default.createElement(_Layer.Layer, args, /*#__PURE__*/_react.default.createElement(_DatePicker.default, (0, _extends2.default)({
    datePickerType: "simple"
  }, args), /*#__PURE__*/_react.default.createElement(_DatePickerInput.default, (0, _extends2.default)({
    placeholder: "mm/dd/yyyy",
    labelText: "Date Picker label",
    id: "date-picker-simple"
  }, args))), /*#__PURE__*/_react.default.createElement(_Layer.Layer, args, /*#__PURE__*/_react.default.createElement(_DatePicker.default, (0, _extends2.default)({
    datePickerType: "simple"
  }, args), /*#__PURE__*/_react.default.createElement(_DatePickerInput.default, (0, _extends2.default)({
    placeholder: "mm/dd/yyyy",
    labelText: "Date Picker label",
    id: "date-picker-simple"
  }, args))))));
};

exports.SimpleWithLayer = SimpleWithLayer;

var SingleWithCalendarWithLayer = function SingleWithCalendarWithLayer(args) {
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_DatePicker.default, (0, _extends2.default)({
    datePickerType: "single"
  }, args), /*#__PURE__*/_react.default.createElement(_DatePickerInput.default, (0, _extends2.default)({
    placeholder: "mm/dd/yyyy",
    labelText: "Date Picker label",
    id: "date-picker-single"
  }, args))), /*#__PURE__*/_react.default.createElement(_Layer.Layer, args, /*#__PURE__*/_react.default.createElement(_DatePicker.default, (0, _extends2.default)({
    datePickerType: "single"
  }, args), /*#__PURE__*/_react.default.createElement(_DatePickerInput.default, (0, _extends2.default)({
    placeholder: "mm/dd/yyyy",
    labelText: "Date Picker label",
    id: "date-picker-single"
  }, args))), /*#__PURE__*/_react.default.createElement(_Layer.Layer, args, /*#__PURE__*/_react.default.createElement(_DatePicker.default, (0, _extends2.default)({
    datePickerType: "single"
  }, args), /*#__PURE__*/_react.default.createElement(_DatePickerInput.default, (0, _extends2.default)({
    placeholder: "mm/dd/yyyy",
    labelText: "Date Picker label",
    id: "date-picker-single"
  }, args))))));
};

exports.SingleWithCalendarWithLayer = SingleWithCalendarWithLayer;

var RangeWithCalendarWithLayer = function RangeWithCalendarWithLayer(args) {
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_DatePicker.default, (0, _extends2.default)({
    datePickerType: "range"
  }, args), /*#__PURE__*/_react.default.createElement(_DatePickerInput.default, (0, _extends2.default)({
    id: "date-picker-input-id-start",
    placeholder: "mm/dd/yyyy",
    labelText: "Start date"
  }, args)), /*#__PURE__*/_react.default.createElement(_DatePickerInput.default, (0, _extends2.default)({
    id: "date-picker-input-id-finish",
    placeholder: "mm/dd/yyyy",
    labelText: "End date"
  }, args))), /*#__PURE__*/_react.default.createElement(_Layer.Layer, args, /*#__PURE__*/_react.default.createElement(_DatePicker.default, (0, _extends2.default)({
    datePickerType: "range"
  }, args), /*#__PURE__*/_react.default.createElement(_DatePickerInput.default, (0, _extends2.default)({
    id: "date-picker-input-id-start",
    placeholder: "mm/dd/yyyy",
    labelText: "Start date"
  }, args)), /*#__PURE__*/_react.default.createElement(_DatePickerInput.default, (0, _extends2.default)({
    id: "date-picker-input-id-finish",
    placeholder: "mm/dd/yyyy",
    labelText: "End date"
  }, args))), /*#__PURE__*/_react.default.createElement(_Layer.Layer, args, /*#__PURE__*/_react.default.createElement(_DatePicker.default, (0, _extends2.default)({
    datePickerType: "range"
  }, args), /*#__PURE__*/_react.default.createElement(_DatePickerInput.default, (0, _extends2.default)({
    id: "date-picker-input-id-start",
    placeholder: "mm/dd/yyyy",
    labelText: "Start date"
  }, args)), /*#__PURE__*/_react.default.createElement(_DatePickerInput.default, (0, _extends2.default)({
    id: "date-picker-input-id-finish",
    placeholder: "mm/dd/yyyy",
    labelText: "End date"
  }, args))))));
};
/* eslint-disable react/prop-types */


exports.RangeWithCalendarWithLayer = RangeWithCalendarWithLayer;

var DatePickerPlayground = function DatePickerPlayground() {
  return /*#__PURE__*/_react.default.createElement(_DatePicker.default, props.datePicker(), /*#__PURE__*/_react.default.createElement(_DatePickerInput.default, props.datePickerInput()), props.datePicker().datePickerType === 'range' && /*#__PURE__*/_react.default.createElement(_DatePickerInput.default, (0, _extends2.default)({}, props.datePickerInput(), {
    id: "date-picker-input-2"
  })));
};
/* eslint-enable react/prop-types */


exports.DatePickerPlayground = DatePickerPlayground;

var Skeleton = function Skeleton() {
  return /*#__PURE__*/_react.default.createElement(_DatePicker2.default, {
    range: true
  });
};

exports.Skeleton = Skeleton;