"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.Nested = exports.NativeListStyles = exports.Default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireDefault(require("react"));

var _OrderedList = _interopRequireDefault(require("../OrderedList"));

var _addonKnobs = require("@storybook/addon-knobs");

var _ListItem = _interopRequireDefault(require("../ListItem"));

var _OrderedList2 = _interopRequireDefault(require("./OrderedList.mdx"));

var props = {
  regular: function regular() {
    return {
      isExpressive: (0, _addonKnobs.boolean)('Expressive', false)
    };
  }
};
var _default = {
  title: 'Components/OrderedList',
  component: _OrderedList.default,
  decorators: [_addonKnobs.withKnobs],
  parameters: {
    docs: {
      page: _OrderedList2.default
    }
  },
  subcomponents: {
    ListItem: _ListItem.default
  }
};
exports.default = _default;

var Default = function Default() {
  return /*#__PURE__*/_react.default.createElement(_OrderedList.default, null, /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 1"), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 1"), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 1"), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 1"), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 1"), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 1"), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 1"), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 1"), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 1"), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 1"), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 1"), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 1"), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 1"));
};

exports.Default = Default;
Default.storyName = 'default';
Default.parameters = {
  info: {
    text: "Lists consist of related content grouped together and organized vertically. Ordered lists are used to present content in a numbered list."
  }
};

var Nested = function Nested() {
  var regularProps = props.regular();
  return /*#__PURE__*/_react.default.createElement(_OrderedList.default, regularProps, /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 1", /*#__PURE__*/_react.default.createElement(_OrderedList.default, {
    nested: true
  }, /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 2"), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 2", /*#__PURE__*/_react.default.createElement(_OrderedList.default, {
    nested: true
  }, /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 3"), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 3"))))), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 1"), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 1"));
};

exports.Nested = Nested;
Nested.storyName = 'nested';
Nested.parameters = {
  info: {
    text: "Lists consist of related content grouped together and organized vertically. Ordered lists are used to present content in a numbered list."
  }
};

var NativeListStyles = function NativeListStyles() {
  var regularProps = props.regular();
  return /*#__PURE__*/_react.default.createElement(_OrderedList.default, (0, _extends2.default)({
    native: true
  }, regularProps), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 1"), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 1"), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 1"), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 1", /*#__PURE__*/_react.default.createElement(_OrderedList.default, {
    nested: true
  }, /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 2"), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 2"), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 2"), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 2"))), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 1"), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 1"), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 1"), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 1"), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 1"), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 1"), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 1"), /*#__PURE__*/_react.default.createElement(_ListItem.default, null, "Ordered List level 1"));
};

exports.NativeListStyles = NativeListStyles;
Default.storyName = 'native styles';
NativeListStyles.parameters = {
  info: {
    text: "Lists consist of related content grouped together and organized vertically. Ordered lists are used to present content in a numbered list."
  }
};