"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createTextComponent = createTextComponent;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireDefault(require("react"));

var _Text = require("./Text");

/**
 * Copyright IBM Corp. 2016, 2018
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

/**
 * Create a text component wrapper for a given text node type. Useful for
 * returning a `Text` component for a text node like a `<label>`.
 * @param {string} element
 * @param {string} displayName
 */
function createTextComponent(element, displayName) {
  function TextWrapper(props) {
    return /*#__PURE__*/_react.default.createElement(_Text.Text, (0, _extends2.default)({
      as: element
    }, props));
  }

  if (process.env.NODE_ENV !== "production") {
    TextWrapper.displayName = displayName;
  }

  return TextWrapper;
}