"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.Playground = exports.Duration = exports.Default = exports.Alignment = void 0;

require("./story.scss");

var _iconsReact = require("@carbon/icons-react");

var _react = _interopRequireDefault(require("react"));

var _ = require("./");

var _Tooltip = _interopRequireDefault(require("./Tooltip.mdx"));

/**
 * Copyright IBM Corp. 2016, 2018
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
var _default = {
  title: 'Components/Tooltip',
  component: _.Tooltip,
  parameters: {
    controls: {
      hideNoControlsWarning: true
    },
    layout: 'centered',
    docs: {
      page: _Tooltip.default
    }
  },
  argTypes: {
    children: {
      table: {
        disable: true
      }
    },
    className: {
      table: {
        disable: true
      }
    }
  },
  decorators: [function (Story) {
    return /*#__PURE__*/_react.default.createElement("div", {
      className: "sb-tooltip-story"
    }, /*#__PURE__*/_react.default.createElement(Story, null));
  }]
};
exports.default = _default;

var Default = function Default() {
  var label = 'Occassionally, services are updated in a specified time window to ensure no down time for customers.';
  return /*#__PURE__*/_react.default.createElement(_.Tooltip, {
    align: "bottom",
    label: label
  }, /*#__PURE__*/_react.default.createElement("button", {
    className: "sb-tooltip-trigger",
    type: "button"
  }, /*#__PURE__*/_react.default.createElement(_iconsReact.Information16, null)));
};

exports.Default = Default;

var Alignment = function Alignment() {
  return /*#__PURE__*/_react.default.createElement(_.Tooltip, {
    label: "Tooltip alignment",
    align: "bottom-left"
  }, /*#__PURE__*/_react.default.createElement("button", {
    className: "sb-tooltip-trigger",
    type: "button"
  }, /*#__PURE__*/_react.default.createElement(_iconsReact.Information16, null)));
};

exports.Alignment = Alignment;

var Duration = function Duration() {
  return /*#__PURE__*/_react.default.createElement(_.Tooltip, {
    label: "Label one",
    enterDelayMs: 0,
    leaveDelayMs: 300
  }, /*#__PURE__*/_react.default.createElement("button", {
    className: "sb-tooltip-trigger",
    type: "button"
  }, /*#__PURE__*/_react.default.createElement(_iconsReact.Information16, null)));
};

exports.Duration = Duration;

var PlaygroundStory = function PlaygroundStory(props) {
  var align = props.align,
      defaultOpen = props.defaultOpen,
      description = props.description,
      enterDelayMs = props.enterDelayMs,
      label = props.label,
      leaveDelayMs = props.leaveDelayMs;
  return /*#__PURE__*/_react.default.createElement(_.Tooltip, {
    align: align,
    defaultOpen: defaultOpen,
    description: description,
    enterDelayMs: enterDelayMs,
    label: label,
    leaveDelayMs: leaveDelayMs
  }, /*#__PURE__*/_react.default.createElement("button", {
    className: "sb-tooltip-trigger",
    type: "button"
  }, /*#__PURE__*/_react.default.createElement(_iconsReact.Information16, null)));
};

var Playground = PlaygroundStory.bind({});
exports.Playground = Playground;
Playground.argTypes = {
  align: {
    defaultValue: 'bottom',
    options: ['top', 'top-left', 'top-right', 'bottom', 'bottom-left', 'bottom-right', 'left', 'left-bottom', 'left-top', 'right', 'right-bottom', 'right-top'],
    control: {
      type: 'select'
    }
  },
  defaultOpen: {
    defaultValue: true
  },
  label: {
    control: {
      type: 'text'
    },
    defaultValue: 'Custom label'
  },
  description: {
    control: {
      type: 'text'
    }
  }
};