"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createClassWrapper = createClassWrapper;

var _react = _interopRequireDefault(require("react"));

/**
 * Copyright IBM Corp. 2016, 2018
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

/**
 * Wrap a class component with a functional component. This prevents an end-user
 * from being able to pass `ref` and access the underlying class instance.
 *
 * @param {ReactNode} Component
 * @returns {ReactNode}
 */
function createClassWrapper(Component) {
  function ClassWrapper(props) {
    return /*#__PURE__*/_react.default.createElement(Component, props);
  }

  if (process.env.NODE_ENV !== "production") {
    var name = Component.displayName || Component.name;
    ClassWrapper.displayName = "ClassWrapper(".concat(name, ")");
  }

  return ClassWrapper;
}